      SUBROUTINE ZP16R(A,NREAL,ROOT,IERR)
      INTEGER NREAL,IERR
      REAL A,X,Y,Z,P,Q,R,R1,R2,ROOT,SYS007
      REAL ABS,ATAN2,AMIN1,AMAX1,SIGN,COS,SQRT
      DIMENSION A(4),ROOT(3)
      DATA SYS007/1.047198/
      IERR=0
      R1=3.*A(1)
      IF(A(1).NE.0.) GO TO 11
      IERR=65
      CALL UTZP10(IERR,16)
      GO TO 9005
   11 R2=A(2)/R1
      X=A(3)/R1-R2**2
      Y=3.*A(4)/R1+2.*R2**3-3.*R2*(A(3)/R1)
      Z=-2.*SQRT(ABS(X))
      IF(X.NE.0..OR.Y.NE.0.) GO TO 12
      NREAL=3
      ROOT(1)=-R2
      ROOT(2)=ROOT(1)
      ROOT(3)=ROOT(1)
      GO TO 9005
   12 IF(ABS(Y)-X*Z) 13,15,14
   13 NREAL=3
      Y=(Y/X)/Z
      Y=(2./3.)*ATAN2(SQRT(1.-Y),SQRT(1.+Y))
      P=Z*COS(Y)-R2
      X=-Z*COS(Y-SYS007)-R2
      Y=-Z*COS(Y+SYS007)-R2
      ROOT(1)=AMIN1(P,X,Y)
      ROOT(3)=AMAX1(P,X,Y)
      ROOT(2)=-A(2)/A(1)-ROOT(1)-ROOT(3)
      GO TO 9005
   14 Z=X*Z
      R1=AMAX1(ABS(Y),ABS(Z))
      Z=R1*SQRT((Y/R1)**2-(Z/R1)*(ABS(Z)/R1))
      IF( Z.EQ.0. ) GO TO 16
      Z=0.5*(Z+(Y/Z)*Y+(4.*X/Z)*X*X)
      GO TO 16
   15 Z=0.
   16 NREAL=1
      P=Y+Z
      X=SIGN((SQRT(0.5)*SQRT(ABS(P)))**(2./3.),P)
      P=Y-Z
      Y=SIGN((SQRT(0.5)*SQRT(ABS(P)))**(2./3.),P)
      Z=X+Y
      ROOT(1)=-Z-R2
      ROOT(2)=0.5*Z-R2
      ROOT(3)=SQRT(0.75)*ABS(X-Y)
 9005 RETURN
      END
